/* $Id: black.c,v 1.335 2006-02-17 06:41:34 cartho Exp $ */

#include "config.h"
#include <stdlib.h>
#include <stdio.h>
#include "sys.h"
#include "cnt.h"
#include "java.h"
#include "test.h"

/*------------------------------------------------------------------------*/
#ifdef JNUKE_TEST
/*------------------------------------------------------------------------*/

void
JNuke_javablack (JNukeTest * test)
{
  SUITE ("java", test);
  GROUP ("indexpair");
  FAST (java, indexpair, 0);
  FAST (java, indexpair, 1);
  FAST (java, indexpair, 2);
  FAST (java, indexpair, 3);
  GROUP ("abytecode");
  FAST (java, abytecode, 0);
  FAST (java, abytecode, 1);
  FAST (java, abytecode, 2);
  FAST (java, abytecode, 3);
  FAST (java, abytecode, 4);
  FAST (java, abytecode, 5);
  FAST (java, abytecode, 6);
  FAST (java, abytecode, 7);
  GROUP ("rbytecode");
  FAST (java, rbytecode, 0);
  FAST (java, rbytecode, 1);
  FAST (java, rbytecode, 2);
  FAST (java, rbytecode, 3);
  FAST (java, rbytecode, 4);
  FAST (java, rbytecode, 5);
  FAST (java, rbytecode, 6);
  FAST (java, rbytecode, 7);
  FAST (java, rbytecode, 8);
  GROUP ("bytecode");
  FAST (java, bytecode, 0);
  FAST (java, bytecode, 1);
  FAST (java, bytecode, 2);
  FAST (java, bytecode, 3);
  FAST (java, bytecode, 4);
  GROUP ("FieldArgs");
  FAST (java, FieldArgs, 0);
  GROUP ("bct");
  FAST (java, bct, 0);
  GROUP ("rbct");
  FAST (java, rbct, 0);
  FAST (java, rbct, 1);
  GROUP ("ot");
  FAST (java, ot, 0);
  FAST (java, ot, 1);
  FAST (java, ot, 2);
  FAST (java, ot, 3);
  FAST (java, ot, 4);
  FAST (java, ot, 5);
  FAST (java, ot, 6);
  FAST (java, ot, 7);
  FAST (java, ot, 8);
  FAST (java, ot, 9);
  FAST (java, ot, 10);
  FAST (java, ot, 11);
  GROUP ("classpool");
  FAST (java, classpool, 0);
  FAST (java, classpool, 1);
  SLOW (java, classpool, 2);
  FAST (java, classpool, 3);
  SLOW (java, classpool, 4);
  FAST (java, classpool, 5);
  FAST (java, classpool, 6);
  FAST (java, classpool, 7);
  FAST (java, classpool, 8);
  GROUP ("classloader");
  FAST (java, classloader, 0);
  FAST (java, classloader, 1);
  FAST (java, classloader, 2);
  FAST (java, classloader, 3);
  FAST (java, classloader, 4);
  FAST (java, classloader, 5);
  FAST (java, classloader, 6);
  FAST (java, classloader, 7);
  FAST (java, classloader, 8);
  FAST (java, classloader, 9);
  FAST (java, classloader, 10);
  FAST (java, classloader, 11);
  FAST (java, classloader, 12);
  FAST (java, classloader, 13);
  FAST (java, classloader, 14);
  FAST (java, classloader, 15);
  FAST (java, classloader, 16);
  FAST (java, classloader, 17);
  FAST (java, classloader, 18);
  /* these slots have intentionally been left blank */
  FAST (java, classloader, 21);
  FAST (java, classloader, 22);
  FAST (java, classloader, 23);
  FAST (java, classloader, 24);
  FAST (java, classloader, 25);
  FAST (java, classloader, 26);
  FAST (java, classloader, 27);
  FAST (java, classloader, 28);
  /* more intentionally blank slots */
  FAST (java, classloader, 31);
  FAST (java, classloader, 32);
  FAST (java, classloader, 33);
  FAST (java, classloader, 34);
  FAST (java, classloader, 35);
  FAST (java, classloader, 36);
  FAST (java, classloader, 37);
  FAST (java, classloader, 38);
  FAST (java, classloader, 39);
  FAST (java, classloader, 40);
  FAST (java, classloader, 41);
  FAST (java, classloader, 42);
  FAST (java, classloader, 43);
  FAST (java, classloader, 44);
  FAST (java, classloader, 45);
  FAST (java, classloader, 46);
  FAST (java, classloader, 47);
  FAST (java, classloader, 49);
  FAST (java, classloader, 50);
  FAST (java, classloader, 51);
  FAST (java, classloader, 52);
  FAST (java, classloader, 53);
  FAST (java, classloader, 54);
  FAST (java, classloader, 55);
  FAST (java, classloader, 56);
  FAST (java, classloader, 57);
  FAST (java, classloader, 58);
  FAST (java, classloader, 59);
  FAST (java, classloader, 60);
  FAST (java, classloader, 61);
  FAST (java, classloader, 62);
  FAST (java, classloader, 63);
  FAST (java, classloader, 64);
  FAST (java, classloader, 65);
  FAST (java, classloader, 66);
  FAST (java, classloader, 69);
  FAST (java, classloader, 78);
  FAST (java, classloader, 79);
  FAST (java, classloader, 80);
  FAST (java, classloader, 81);
  FAST (java, classloader, 82);
  SLOW (java, classloader, 83);
  SLOW (java, classloader, 84);
  SLOW (java, classloader, 85);
  SLOW (java, classloader, 86);
  FAST (java, classloader, 87);
  FAST (java, classloader, 88);
  FAST (java, classloader, 89);
  FAST (java, classloader, 90);
  SLOW (java, classloader, 91);
  SLOW (java, classloader, 92);
  FAST (java, classloader, 93);
  FAST (java, classloader, 94);
  FAST (java, classloader, 95);
  FAST (java, classloader, 96);
  SLOW (java, classloader, 97);
  SLOW (java, classloader, 98);
  SLOW (java, classloader, 99);
  SLOW (java, classloader, 100);
  FAST (java, classloader, 101);
  FAST (java, classloader, 102);
  FAST (java, classloader, 103);
  FAST (java, classloader, 104);
  FAST (java, classloader, 105);
  FAST (java, classloader, 106);
  SLOW (java, classloader, 107);
  SLOW (java, classloader, 108);
  SLOW (java, classloader, 109);
  SLOW (java, classloader, 110);
  FAST (java, classloader, 111);
  FAST (java, classloader, 112);
  FAST (java, classloader, 113);
  FAST (java, classloader, 114);
  FAST (java, classloader, 115);
  FAST (java, classloader, 116);
  FAST (java, classloader, 117);
  FAST (java, classloader, 118);
  FAST (java, classloader, 119);
  FAST (java, classloader, 120);
  FAST (java, classloader, 121);
  FAST (java, classloader, 122);
  FAST (java, classloader, 123);
  FAST (java, classloader, 124);
  FAST (java, classloader, 125);
  FAST (java, classloader, 126);
  FAST (java, classloader, 127);
  FAST (java, classloader, 128);
  FAST (java, classloader, 129);
  FAST (java, classloader, 130);
  FAST (java, classloader, 131);
  FAST (java, classloader, 132);
  FAST (java, classloader, 133);
  FAST (java, classloader, 134);
  FAST (java, classloader, 135);
  FAST (java, classloader, 136);
  FAST (java, classloader, 137);
  FAST (java, classloader, 138);
  FAST (java, classloader, 139);
  FAST (java, classloader, 140);
  FAST (java, classloader, 141);
  FAST (java, classloader, 142);
  FAST (java, classloader, 143);
  FAST (java, classloader, 144);
  FAST (java, classloader, 145);
  FAST (java, classloader, 146);
  FAST (java, classloader, 147);
  FAST (java, classloader, 148);
  FAST (java, classloader, 149);
  FAST (java, classloader, 150);
  FAST (java, classloader, 151);
  FAST (java, classloader, 152);
  FAST (java, classloader, 153);
  FAST (java, classloader, 154);
  FAST (java, classloader, 155);
  FAST (java, classloader, 156);
  FAST (java, classloader, 157);
  FAST (java, classloader, 158);
  FAST (java, classloader, 159);
  FAST (java, classloader, 160);
  FAST (java, classloader, 161);
  FAST (java, classloader, 162);
  FAST (java, classloader, 163);
  FAST (java, classloader, 164);
  FAST (java, classloader, 165);
  FAST (java, classloader, 166);
  FAST (java, classloader, 167);
  FAST (java, classloader, 168);
  FAST (java, classloader, 169);
  FAST (java, classloader, 170);
  FAST (java, classloader, 171);
  FAST (java, classloader, 172);
  FAST (java, classloader, 173);
  FAST (java, classloader, 174);
  FAST (java, classloader, 175);
  FAST (java, classloader, 176);
  FAST (java, classloader, 177);
  FAST (java, classloader, 178);
  FAST (java, classloader, 179);
  FAST (java, classloader, 180);
  FAST (java, classloader, 181);
  FAST (java, classloader, 182);
  FAST (java, classloader, 183);
  FAST (java, classloader, 184);
  FAST (java, classloader, 185);
  FAST (java, classloader, 186);
  FAST (java, classloader, 187);
  FAST (java, classloader, 188);
  FAST (java, classloader, 189);
  FAST (java, classloader, 190);
  FAST (java, classloader, 191);
  FAST (java, classloader, 192);
  FAST (java, classloader, 193);
  FAST (java, classloader, 194);
  FAST (java, classloader, 195);
  FAST (java, classloader, 196);
  FAST (java, classloader, 197);
  FAST (java, classloader, 198);
  SLOW (java, classloader, 199);
  FAST (java, classloader, 200);
  SLOW (java, classloader, 201);
  FAST (java, classloader, 202);
  FAST (java, classloader, 203);
  SLOW (java, classloader, 204);
  FAST (java, classloader, 205);
  FAST (java, classloader, 206);
  FAST (java, classloader, 207);
  FAST (java, classloader, 208);
  FAST (java, classloader, 209);
  FAST (java, classloader, 210);
  FAST (java, classloader, 211);
  FAST (java, classloader, 212);
  FAST (java, classloader, 213);
  FAST (java, classloader, 214);
  FAST (java, classloader, 215);
  FAST (java, classloader, 216);
  FAST (java, classloader, 217);
  SLOW (java, classloader, 218);
  FAST (java, classloader, 219);
  FAST (java, classloader, 220);
  FAST (java, classloader, 221);
  FAST (java, classloader, 222);
  FAST (java, classloader, 223);
  FAST (java, classloader, 224);
  FAST (java, classloader, 225);
  FAST (java, classloader, 226);
  FAST (java, classloader, 227);
  FAST (java, classloader, 228);
  FAST (java, classloader, 229);
  FAST (java, classloader, 230);
  FAST (java, classloader, 231);
  FAST (java, classloader, 232);
  FAST (java, classloader, 233);
  FAST (java, classloader, 234);
  FAST (java, classloader, 235);
  FAST (java, classloader, 236);
  FAST (java, classloader, 237);
  FAST (java, classloader, 238);
  SLOW (java, classloader, 239);
  FAST (java, classloader, 240);
  FAST (java, classloader, 241);
  FAST (java, classloader, 242);
  FAST (java, classloader, 243);
  FAST (java, classloader, 244);
  FAST (java, classloader, 245);
  FAST (java, classloader, 246);
  FAST (java, classloader, 247);
  FAST (java, classloader, 248);
  FAST (java, classloader, 249);
  FAST (java, classloader, 250);
  FAST (java, classloader, 251);
  GROUP ("classdesc");
  FAST (java, classdesc, 0);
  FAST (java, classdesc, 1);
  FAST (java, classdesc, 2);
  FAST (java, classdesc, 3);
  FAST (java, classdesc, 4);
  FAST (java, classdesc, 5);
  FAST (java, classdesc, 6);
  FAST (java, classdesc, 7);
  FAST (java, classdesc, 8);
  GROUP ("methoddesc");
  FAST (java, methoddesc, 0);
  FAST (java, methoddesc, 1);
  FAST (java, methoddesc, 2);
  FAST (java, methoddesc, 3);
  FAST (java, methoddesc, 4);
  FAST (java, methoddesc, 5);
  FAST (java, methoddesc, 6);
  FAST (java, methoddesc, 7);
  FAST (java, methoddesc, 8);
  FAST (java, methoddesc, 9);
  GROUP ("vardesc");
  FAST (java, vardesc, 0);
  FAST (java, vardesc, 1);
  FAST (java, vardesc, 2);
  FAST (java, vardesc, 3);
  FAST (java, vardesc, 4);
  FAST (java, vardesc, 5);
  FAST (java, vardesc, 6);
  FAST (java, vardesc, 7);
  GROUP ("ehandlerdesc");
  FAST (java, ehandlerdesc, 0);
  FAST (java, ehandlerdesc, 1);
  GROUP ("ehandlertable");
  FAST (java, ehandlertable, 0);
  FAST (java, ehandlertable, 1);
  FAST (java, ehandlertable, 2);
  FAST (java, ehandlertable, 3);
  FAST (java, ehandlertable, 4);
  FAST (java, ehandlertable, 5);
  FAST (java, ehandlertable, 6);
  FAST (java, ehandlertable, 7);
  FAST (java, ehandlertable, 8);
  FAST (java, ehandlertable, 9);
  FAST (java, ehandlertable, 10);
  FAST (java, ehandlertable, 11);
  FAST (java, ehandlertable, 12);
  FAST (java, ehandlertable, 13);
  FAST (java, ehandlertable, 14);
  GROUP ("signaturedesc");
  FAST (java, signaturedesc, 0);
  FAST (java, signaturedesc, 1);
  GROUP ("cfg");
  FAST (java, cfg, 0);
  FAST (java, cfg, 1);
  GROUP ("basicblock");
  FAST (java, basicblock, 0);
  FAST (java, basicblock, 1);
  GROUP ("simplestackdesc");
  FAST (java, simplestackdesc, 0);
  FAST (java, simplestackdesc, 1);
  FAST (java, simplestackdesc, 2);
  FAST (java, simplestackdesc, 3);
  FAST (java, simplestackdesc, 4);
  FAST (java, simplestackdesc, 5);
  GROUP ("constantpool");
  FAST (java, constantpool, 0);
  FAST (java, constantpool, 1);
  FAST (java, constantpool, 2);
  FAST (java, constantpool, 3);
  FAST (java, constantpool, 4);
  FAST (java, constantpool, 5);
  FAST (java, constantpool, 6);
  FAST (java, constantpool, 7);
  FAST (java, constantpool, 8);
  FAST (java, constantpool, 9);
  FAST (java, constantpool, 10);
  FAST (java, constantpool, 11);
  FAST (java, constantpool, 12);
  FAST (java, constantpool, 13);
  FAST (java, constantpool, 14);
  FAST (java, constantpool, 15);
  FAST (java, constantpool, 16);
  FAST (java, constantpool, 17);
  FAST (java, constantpool, 18);
  FAST (java, constantpool, 19);
  FAST (java, constantpool, 20);
  FAST (java, constantpool, 21);
  FAST (java, constantpool, 22);
  FAST (java, constantpool, 23);
  FAST (java, constantpool, 24);
  FAST (java, constantpool, 25);
  SLOW (java, constantpool, 26);
  FAST (java, constantpool, 27);
  FAST (java, constantpool, 28);

  GROUP ("attribute");
  FAST (java, attribute, 0);
  FAST (java, attribute, 1);
  FAST (java, attribute, 2);
  FAST (java, attribute, 3);
  FAST (java, attribute, 4);
  FAST (java, attribute, 5);
  FAST (java, attribute, 6);
  FAST (java, attribute, 7);
  GROUP ("mfinfo");
  FAST (java, mfinfo, 0);
  FAST (java, mfinfo, 1);
  FAST (java, mfinfo, 2);
  FAST (java, mfinfo, 3);
  FAST (java, mfinfo, 4);
  FAST (java, mfinfo, 5);
  FAST (java, mfinfo, 6);
  FAST (java, mfinfo, 7);
  GROUP ("attrfactory");
  FAST (java, attrfactory, 0);
  FAST (java, attrfactory, 1);
  FAST (java, attrfactory, 2);
  FAST (java, attrfactory, 3);
  FAST (java, attrfactory, 4);
  FAST (java, attrfactory, 5);
  FAST (java, attrfactory, 6);
  FAST (java, attrfactory, 7);
  FAST (java, attrfactory, 8);
  FAST (java, attrfactory, 9);
  FAST (java, attrfactory, 10);
  FAST (java, attrfactory, 11);
  FAST (java, attrfactory, 12);
  FAST (java, attrfactory, 13);
  GROUP ("mfinfofactory");
  FAST (java, mfinfofactory, 0);
  FAST (java, mfinfofactory, 1);
  FAST (java, mfinfofactory, 2);
  FAST (java, mfinfofactory, 3);
  FAST (java, mfinfofactory, 4);
  FAST (java, mfinfofactory, 5);
  FAST (java, mfinfofactory, 6);
  FAST (java, mfinfofactory, 7);
  GROUP ("classwriter");
  FAST (java, classwriter, 0);
  FAST (java, classwriter, 1);
  FAST (java, classwriter, 2);
  FAST (java, classwriter, 3);
  FAST (java, classwriter, 4);
  FAST (java, classwriter, 5);
  FAST (java, classwriter, 6);
  FAST (java, classwriter, 7);
  FAST (java, classwriter, 8);
  FAST (java, classwriter, 9);
  FAST (java, classwriter, 10);
  FAST (java, classwriter, 11);
  FAST (java, classwriter, 12);
  FAST (java, classwriter, 13);
  FAST (java, classwriter, 14);
  FAST (java, classwriter, 15);
  FAST (java, classwriter, 16);
  FAST (java, classwriter, 17);
  FAST (java, classwriter, 18);
  FAST (java, classwriter, 19);
  FAST (java, classwriter, 20);
  FAST (java, classwriter, 21);
  FAST (java, classwriter, 22);
  FAST (java, classwriter, 23);
  FAST (java, classwriter, 24);
  FAST (java, classwriter, 25);
  FAST (java, classwriter, 26);
  GROUP ("bcpatch");
  FAST (java, bcpatch, 0);
  FAST (java, bcpatch, 1);
  FAST (java, bcpatch, 2);
  /* removed obsolete test cases */
  FAST (java, bcpatch, 5);
  FAST (java, bcpatch, 6);
  FAST (java, bcpatch, 7);
  FAST (java, bcpatch, 8);
  FAST (java, bcpatch, 9);
  FAST (java, bcpatch, 10);
  GROUP ("instrument");
  FAST (java, instrument, 0);
  FAST (java, instrument, 1);
  FAST (java, instrument, 2);
  FAST (java, instrument, 3);
  FAST (java, instrument, 4);
  FAST (java, instrument, 5);
  FAST (java, instrument, 6);
  FAST (java, instrument, 7);
  FAST (java, instrument, 8);
  FAST (java, instrument, 9);
  FAST (java, instrument, 10);
  FAST (java, instrument, 11);
  FAST (java, instrument, 12);
  FAST (java, instrument, 13);
  FAST (java, instrument, 14);
  /* 15 is obsolete */
  FAST (java, instrument, 16);
  FAST (java, instrument, 17);
  FAST (java, instrument, 18);
  FAST (java, instrument, 19);
  FAST (java, instrument, 20);
  GROUP ("evalfactory");
  FAST (java, evalfactory, 0);
  FAST (java, evalfactory, 1);
  FAST (java, evalfactory, 2);
  FAST (java, evalfactory, 3);
  FAST (java, evalfactory, 4);
  FAST (java, evalfactory, 5);
  FAST (java, evalfactory, 7);
  FAST (java, evalfactory, 8);
  FAST (java, evalfactory, 10);
  FAST (java, evalfactory, 11);
  FAST (java, evalfactory, 12);
  FAST (java, evalfactory, 14);
  FAST (java, evalfactory, 15);
  GROUP ("execfactory");
  FAST (java, execfactory, 0);
  FAST (java, execfactory, 1);
  FAST (java, execfactory, 2);
  FAST (java, execfactory, 3);
  FAST (java, execfactory, 4);
  FAST (java, execfactory, 5);
  FAST (java, execfactory, 6);
  FAST (java, execfactory, 10);
  FAST (java, execfactory, 11);
  FAST (java, execfactory, 12);
  FAST (java, execfactory, 13);
  GROUP ("instrrule");
  FAST (java, instrrule, 0);
  FAST (java, instrrule, 1);
  FAST (java, instrrule, 2);
  FAST (java, instrrule, 3);
  FAST (java, instrrule, 4);
  FAST (java, instrrule, 5);
  FAST (java, instrrule, 6);
  FAST (java, instrrule, 7);
  GROUP ("schedulecondition");
  FAST (java, schedulecondition, 0);
  FAST (java, schedulecondition, 1);
  FAST (java, schedulecondition, 2);
  FAST (java, schedulecondition, 3);
  FAST (java, schedulecondition, 4);
  FAST (java, schedulecondition, 5);
  FAST (java, schedulecondition, 6);
  FAST (java, schedulecondition, 7);
  FAST (java, schedulecondition, 8);
  FAST (java, schedulecondition, 9);
  FAST (java, schedulecondition, 10);
  FAST (java, schedulecondition, 11);
  FAST (java, schedulecondition, 12);
  GROUP ("notrans");
  FAST (java, notrans, 0);
  FAST (java, notrans, 1);
  FAST (java, notrans, 2);
  GROUP ("bcpatchmap");
  FAST (java, bcpatchmap, 0);
  FAST (java, bcpatchmap, 1);
  FAST (java, bcpatchmap, 2);
  FAST (java, bcpatchmap, 3);
  FAST (java, bcpatchmap, 4);
  FAST (java, bcpatchmap, 5);
  GROUP ("replayfacility");
  SLOW (java, replayfacility, 0);
  SLOW (java, replayfacility, 1);
  FAST (java, replayfacility, 2);
  FAST (java, replayfacility, 3);
  SLOW (java, replayfacility, 4);
  SLOW (java, replayfacility, 5);
  SLOW (java, replayfacility, 6);
  FAST (java, replayfacility, 7);
  SLOW (java, replayfacility, 8);
  SLOW (java, replayfacility, 9);
  SLOW (java, replayfacility, 10);
  FAST (java, replayfacility, 11);
  FAST (java, replayfacility, 12);
  FAST (java, replayfacility, 13);
  SLOW (java, replayfacility, 14);
  SLOW (java, replayfacility, 15);
  SLOW (java, replayfacility, 16);
  FAST (java, replayfacility, 18);
  FAST (java, replayfacility, 19);
  FAST (java, replayfacility, 20);
  FAST (java, replayfacility, 21);
  SLOW (java, replayfacility, 22);
  SLOW (java, replayfacility, 23);
  FAST (java, replayfacility, 24);
  FAST (java, replayfacility, 25);
  SLOW (java, replayfacility, 26);
  FAST (java, replayfacility, 27);
  FAST (java, replayfacility, 28);
  FAST (java, replayfacility, 29);
  GROUP ("sfparser");
  FAST (java, sfparser, 0);
  FAST (java, sfparser, 1);
  FAST (java, sfparser, 2);
  FAST (java, sfparser, 3);
  FAST (java, sfparser, 4);
  FAST (java, sfparser, 5);
  FAST (java, sfparser, 6);
  FAST (java, sfparser, 7);
  FAST (java, sfparser, 8);
  FAST (java, sfparser, 9);
  FAST (java, sfparser, die);
  FAST (java, sfparser, notify);
  FAST (java, sfparser, timeout);
  FAST (java, sfparser, log);
  GROUP ("classpath");
  FAST (java, classpath, 0);
  FAST (java, classpath, 1);
  FAST (java, classpath, 2);
  FAST (java, classpath, 3);
  FAST (java, classpath, 4);
  FAST (java, classpath, 5);
  FAST (java, classpath, 6);
  FAST (java, classpath, 7);
}

/*------------------------------------------------------------------------*/
#else
/*------------------------------------------------------------------------*/

void
JNuke_javablack (JNukeTest * t)
{
  (void) t;
}

/*------------------------------------------------------------------------*/
#endif
/*------------------------------------------------------------------------*/
