/* $Id: black.c,v 1.197 2006-02-20 04:26:16 cartho Exp $ */

#include "config.h"
#include <stdlib.h>
#include <stdio.h>
#include "sys.h"
#include "cnt.h"
#include "java.h"
#include "test.h"

/*------------------------------------------------------------------------*/
#ifdef JNUKE_TEST
/*------------------------------------------------------------------------*/

void
JNuke_rvblack (JNukeTest * test)
{
  SUITE ("rv", test);
  GROUP ("rtcontext");
  FAST (rv, rtcontext, 0);
  GROUP ("rv");
  FAST (rv, rv, 0);
  FAST (rv, rv, 1);
  FAST (rv, rv, 2);
  SLOW (rv, rv, 3);
  FAST (rv, rv, 4);
  SLOW (rv, rv, 5);
  SLOW (rv, rv, 6);
  SLOW (rv, rv, 7);
  SLOW (rv, rv, 8);
  SLOW (rv, rv, 9);
  SLOW (rv, rv, 10);
  SLOW (rv, rv, 11);
  SLOW (rv, rv, 12);
  SLOW (rv, rv, 13);
  SLOW (rv, rv, 14);
  SLOW (rv, rv, 15);
  SLOW (rv, rv, 16);
  SLOW (rv, rv, 17);
  SLOW (rv, rv, 18);
  SLOW (rv, rv, 19);
  GROUP ("dynamicla");
  FAST (rv, dynamicla, 0);
  SLOW (rv, dynamicla, 1);
  SLOW (rv, dynamicla, 2);
  SLOW (rv, dynamicla, 3);
  SLOW (rv, dynamicla, 4);
  SLOW (rv, dynamicla, 5);
  SLOW (rv, dynamicla, 6);
  SLOW (rv, dynamicla, 7);
  BENCHMARK (rv, dynamicla, 8);
  SLOW (rv, dynamicla, 11);
  SLOW (rv, dynamicla, 12);
  SLOW (rv, dynamicla, 13);
  SLOW (rv, dynamicla, 14);
  SLOW (rv, dynamicla, 15);
  BENCHMARK (rv, dynamicla, 16);
  BENCHMARK (rv, dynamicla, 17);
  SLOW (rv, dynamicla, 18);
  SLOW (rv, dynamicla, 19);
  SLOW (rv, dynamicla, 20);
  SLOW (rv, dynamicla, 21);
  BENCHMARK (rv, dynamicla, 22);
  BENCHMARK (rv, dynamicla, 23);
  SLOW (rv, dynamicla, 24);
  BENCHMARK (rv, dynamicla, 25);
  BENCHMARK (rv, dynamicla, 26);
  SLOW (rv, dynamicla, 27);
  BENCHMARK (rv, dynamicla, 51);
  BENCHMARK (rv, dynamicla, 52);
  BENCHMARK (rv, dynamicla, 53);
  BENCHMARK (rv, dynamicla, 54);
  BENCHMARK (rv, dynamicla, 55);
  GROUP ("threadsplitter");
  FAST (rv, threadsplitter, 0);
  SLOW (rv, threadsplitter, 1);
  SLOW (rv, threadsplitter, 2);
  SLOW (rv, threadsplitter, 3);
  SLOW (rv, threadsplitter, 4);
  SLOW (rv, threadsplitter, 5);
  SLOW (rv, threadsplitter, 6);
  SLOW (rv, threadsplitter, 7);
  SLOW (rv, threadsplitter, 8);
  SLOW (rv, threadsplitter, 10);
  GROUP ("vc");
  FAST (rv, vc, 0);
  SLOW (rv, vc, 1);
  SLOW (rv, vc, 2);
  SLOW (rv, vc, 3);
  SLOW (rv, vc, 4);
  SLOW (rv, vc, 5);
  SLOW (rv, vc, 6);
  SLOW (rv, vc, 7);
  SLOW (rv, vc, 8);
  SLOW (rv, vc, 9);
  SLOW (rv, vc, 10);
  SLOW (rv, vc, 11);
  SLOW (rv, vc, 12);
  SLOW (rv, vc, 13);
  FAST (rv, vc, 14);
  SLOW (rv, vc, 15);
  SLOW (rv, vc, 16);
  SLOW (rv, vc, 17);
  SLOW (rv, vc, 18);
  SLOW (rv, vc, 19);
  SLOW (rv, vc, 21);
  SLOW (rv, vc, santa);
  BENCHMARK (rv, vc, 22);
  BENCHMARK (rv, vc, 23);
  SLOW (rv, vc, 24);
  SLOW (rv, vc, 25);
  BENCHMARK (rv, vc, 26);
  BENCHMARK (rv, vc, 27);
  BENCHMARK (rv, vc, 28);
  BENCHMARK (rv, vc, 29);
  SLOW (rv, vc, 30);
  BENCHMARK (rv, vc, 31);
  BENCHMARK (rv, vc, 32);
  BENCHMARK (rv, vc, 33);
  BENCHMARK (rv, vc, 34);
  BENCHMARK (rv, vc, 36);
  SLOW (rv, vc, 39);
  BENCHMARK (rv, vc, 40);
  BENCHMARK (rv, vc, 41);
  BENCHMARK (rv, vc, 51);
  BENCHMARK (rv, vc, 52);
  BENCHMARK (rv, vc, 53);
  BENCHMARK (rv, vc, 54);
  BENCHMARK (rv, vc, 55);

  GROUP ("eraser");
  FAST (rv, eraser, 0);
  SLOW (rv, eraser, 1);
  SLOW (rv, eraser, 2);
  SLOW (rv, eraser, 3);
  SLOW (rv, eraser, 4);
  SLOW (rv, eraser, 5);
  SLOW (rv, eraser, 6);
  SLOW (rv, eraser, 7);
  SLOW (rv, eraser, 8);
  SLOW (rv, eraser, 9);
  SLOW (rv, eraser, 10);
  SLOW (rv, eraser, 11);
  SLOW (rv, eraser, 12);
  SLOW (rv, eraser, 13);
  SLOW (rv, eraser, 14);
  SLOW (rv, eraser, 15);
  SLOW (rv, eraser, 16);
  SLOW (rv, eraser, 17);
  SLOW (rv, eraser, 18);
  SLOW (rv, eraser, 19);
  SLOW (rv, eraser, 20);
  SLOW (rv, eraser, 21);
  SLOW (rv, eraser, 22);
  SLOW (rv, eraser, 23);
  SLOW (rv, eraser, 24);
  SLOW (rv, eraser, 25);
  SLOW (rv, eraser, 26);
  SLOW (rv, eraser, 27);
  SLOW (rv, eraser, 28);
  SLOW (rv, eraser, 29);
  BENCHMARK (rv, eraser, 30);
  BENCHMARK (rv, eraser, 31);
  BENCHMARK (rv, eraser, 32);
  BENCHMARK (rv, eraser, 33);
  BENCHMARK (rv, eraser, 34);
  BENCHMARK (rv, eraser, 35);
  BENCHMARK (rv, eraser, 36);
  BENCHMARK (rv, eraser, 37);
  BENCHMARK (rv, eraser, 38);
  BENCHMARK (rv, eraser, 39);
  BENCHMARK (rv, eraser, 41);
  SLOW (rv, eraser, 42);
  SLOW (rv, eraser, 43);
  SLOW (rv, eraser, 44);
  SLOW (rv, eraser, santa);
  BENCHMARK (rv, eraser, 45);
  BENCHMARK (rv, eraser, 46);
  SLOW (rv, eraser, 47);
  BENCHMARK (rv, eraser, 51);
  BENCHMARK (rv, eraser, 52);
  BENCHMARK (rv, eraser, 53);
  BENCHMARK (rv, eraser, 54);
  BENCHMARK (rv, eraser, 55);
  GROUP ("eraserinfo");
  FAST (rv, eraserinfo, 0);
  FAST (rv, eraserinfo, 1);
  GROUP ("exception");
  FAST (rv, exception, 0);
  FAST (rv, exception, 1);
  FAST (rv, exception, 2);
  FAST (rv, exception, 3);
  GROUP ("field");
  FAST (rv, field, 0);
  FAST (rv, field, 1);
  FAST (rv, field, 2);
  FAST (rv, field, 3);
  FAST (rv, field, 4);
  FAST (rv, field, 5);
  GROUP ("fieldaccess");
  FAST (rv, fieldaccess, 0);
  FAST (rv, fieldaccess, 1);
  FAST (rv, fieldaccess, 2);
  FAST (rv, fieldaccess, 3);
  FAST (rv, fieldaccess, 4);
  FAST (rv, fieldaccess, 5);
  FAST (rv, fieldaccess, 6);
  FAST (rv, fieldaccess, 7);
  GROUP ("lockaccess");
  FAST (rv, lockaccess, 0);
  GROUP ("methodevent");
  FAST (rv, methodevent, 0);
  FAST (rv, methodevent, 1);
  GROUP ("view");
  FAST (rv, view, 0);
  FAST (rv, view, 1);
  FAST (rv, view, 2);
  FAST (rv, view, 3);
  FAST (rv, view, 4);
  FAST (rv, view, 5);
  FAST (rv, view, 6);
  FAST (rv, view, 7);
  FAST (rv, view, 8);
  GROUP ("views");
  FAST (rv, views, 0);
  FAST (rv, views, 1);
  FAST (rv, views, 2);
  FAST (rv, views, 3);
  FAST (rv, views, 4);
  GROUP ("maxviews");
  FAST (rv, maxviews, 0);
  FAST (rv, maxviews, 1);
  FAST (rv, maxviews, 2);
  FAST (rv, maxviews, 3);
  FAST (rv, maxviews, 4);
  GROUP ("lockinfo");
  FAST (rv, lockinfo, 0);
  FAST (rv, lockinfo, 1);
  GROUP ("threadinfo");
  FAST (rv, threadinfo, 0);
  FAST (rv, threadinfo, 1);
  GROUP ("lockhistory");
  FAST (rv, lockhistory, 0);
  SLOW (rv, lockhistory, 1);
  FAST (rv, lockhistory, 2);
  SLOW (rv, lockhistory, 3);
  GROUP ("threadhistory");
  FAST (rv, threadhistory, 0);
  FAST (rv, threadhistory, 1);
  FAST (rv, threadhistory, 2);
  SLOW (rv, threadhistory, 3);
  GROUP ("exitblock");
  SLOW (rv, exitblock, 0);
  SLOW (rv, exitblock, 1);
  SLOW (rv, exitblock, 2);
  SLOW (rv, exitblock, 3);
  SLOW (rv, exitblock, 4);
  SLOW (rv, exitblock, 5);
  SLOW (rv, exitblock, 6);
  SLOW (rv, exitblock, 7);
  SLOW (rv, exitblock, 8);
  SLOW (rv, exitblock, 9);
  SLOW (rv, exitblock, 10);
  SLOW (rv, exitblock, 11);
  SLOW (rv, exitblock, 12);
  SLOW (rv, exitblock, 13);
  SLOW (rv, exitblock, 14);
  SLOW (rv, exitblock, 15);
  SLOW (rv, exitblock, 16);
  SLOW (rv, exitblock, 17);
  SLOW (rv, exitblock, 18);
  BENCHMARK (rv, exitblock, 19);
  SLOW (rv, exitblock, 20);
  BENCHMARK (rv, exitblock, 21);
  BENCHMARK (rv, exitblock, 22);
  SLOW (rv, exitblock, 23);
  SLOW (rv, exitblock, 24);
  SLOW (rv, exitblock, 25);
  SLOW (rv, exitblock, 26);
  SLOW (rv, exitblock, 27);
  SLOW (rv, exitblock, 28);
  BENCHMARK (rv, exitblock, 29);
  SLOW (rv, exitblock, 30);
  SLOW (rv, exitblock, 31);
  SLOW (rv, exitblock, 32);
  BENCHMARK (rv, exitblock, 33);
  SLOW (rv, exitblock, 34);
  SLOW (rv, exitblock, 35);
  BENCHMARK (rv, exitblock, 36);
  SLOW (rv, exitblock, 37);
  SLOW (rv, exitblock, 38);
  SLOW (rv, exitblock, 39);
  SLOW (rv, exitblock, 40);
  SLOW (rv, exitblock, 41);
  SLOW (rv, exitblock, 42);
  SLOW (rv, exitblock, 43);
  SLOW (rv, exitblock, 44);
  SLOW (rv, exitblock, 45);
  FAST (rv, exitblock, 46);
  FAST (rv, exitblock, 47);
  SLOW (rv, exitblock, 48);
  SLOW (rv, exitblock, 49);
  SLOW (rv, exitblock, 50);
  SLOW (rv, exitblock, 51);
  SLOW (rv, exitblock, 52);
  SLOW (rv, exitblock, 53);
  SLOW (rv, exitblock, 54);
  SLOW (rv, exitblock, 55);
  SLOW (rv, exitblock, 56);
  SLOW (rv, exitblock, 57);
  BENCHMARK (rv, exitblock, 58);
  SLOW (rv, exitblock, 59);
  BENCHMARK (rv, exitblock, 60);
  BENCHMARK (rv, exitblock, 61);
  SLOW (rv, exitblock, 62);
  SLOW (rv, exitblock, 63);
  SLOW (rv, exitblock, 64);
  BENCHMARK (rv, exitblock, 65);
  SLOW (rv, exitblock, 66);
  BENCHMARK (rv, exitblock, 67);
  BENCHMARK (rv, exitblock, 68);
  SLOW (rv, exitblock, 69);
  BENCHMARK (rv, exitblock, 70);
  SLOW (rv, exitblock, 72);
  BENCHMARK (rv, exitblock, 73);
  SLOW (rv, exitblock, gc17);
  SLOW (rv, exitblock, resolve_start);
  /* BENCHMARK (rv, exitblock, 71); consumes lots of memory! */
  BENCHMARK (rv, exitblock, CAV_DP_2_10);
  BENCHMARK (rv, exitblock, CAV_DP_2_10_RW);
  BENCHMARK (rv, exitblock, CAV_DP_2_11);
  BENCHMARK (rv, exitblock, CAV_DP_2_11_RW);
  BENCHMARK (rv, exitblock, CAV_DP_2_12);
  BENCHMARK (rv, exitblock, CAV_DP_2_12_RW);
  BENCHMARK (rv, exitblock, CAV_DP_3_1);
  BENCHMARK (rv, exitblock, CAV_DP_3_1_RW);
  BENCHMARK (rv, exitblock, CAV_DP_3_2);
  BENCHMARK (rv, exitblock, CAV_DP_3_2_RW);
  BENCHMARK (rv, exitblock, CAV_DP_3_3);
  BENCHMARK (rv, exitblock, CAV_DP_3_3_RW);
  BENCHMARK (rv, exitblock, CAV_PC_100);
  BENCHMARK (rv, exitblock, CAV_PC_100_RW);
  BENCHMARK (rv, exitblock, CAV_PC_1000);
  BENCHMARK (rv, exitblock, CAV_PC_1000_RW);
  SLOW (rv, exitblock, swingBaby);
  SLOW (rv, exitblock, indep);
  SLOW (rv, exitblock, indepGen);
  BENCHMARK (rv, exitblock, 74);
  BENCHMARK (rv, exitblock, 75);
  BENCHMARK (rv, exitblock, 76);
  BENCHMARK (rv, exitblock, 77);
  BENCHMARK (rv, exitblock, 78);
  BENCHMARK (rv, exitblock, 79);
  GROUP ("rlcanalyzer");
  FAST (rv, rlcanalyzer, 0);
  SLOW (rv, rlcanalyzer, 1);
  SLOW (rv, rlcanalyzer, 2);
  SLOW (rv, rlcanalyzer, 3);
  SLOW (rv, rlcanalyzer, 4);
  SLOW (rv, rlcanalyzer, 5);
  SLOW (rv, rlcanalyzer, 6);
  SLOW (rv, rlcanalyzer, 7);
  SLOW (rv, rlcanalyzer, 8);
  SLOW (rv, rlcanalyzer, 9);
  SLOW (rv, rlcanalyzer, 10);
  SLOW (rv, rlcanalyzer, 11);
  SLOW (rv, rlcanalyzer, 12);
  SLOW (rv, rlcanalyzer, 13);
  SLOW (rv, rlcanalyzer, 14);
}

/*------------------------------------------------------------------------*/
#else
/*------------------------------------------------------------------------*/

void
JNuke_rvblack (JNukeTest * t)
{
  (void) t;
}

/*------------------------------------------------------------------------*/
#endif
/*------------------------------------------------------------------------*/
